using System;
using System.Collections.Generic;
using System.Text;
using RPI_IOBoard;
using System.Reflection;
using Microsoft.Win32;

namespace iob_com
{
    class Program
    {
        static void Main(string[] args)
        {
            // necessary to make C# projects work with different installed versions of Mobile Studio Desktop
            AppDomain.CurrentDomain.AssemblyResolve += new ResolveEventHandler(CurrentDomain_AssemblyResolve);

            // call the actual main function
            // (need separate function, or CLR will try to load RPI_IOBoard before ResolveEventHandler is set up) 
            _main();
        }

        private static void _main()
        {
            IOBoard iob = new IOBoard();
            string result;

            int num_devices = iob.getNumDevices();
            Console.WriteLine("getNumDevices() found {0} devices", num_devices);
            if (num_devices < 1) return;

            result = iob.openDevice(1);
            Console.WriteLine("openDevice() returned '{0}'", result);

            IDigitalIO dig_io = (IDigitalIO)iob;
            bool direction = dig_io.getDigitalDirection(1);
            Console.WriteLine("getDigitalDirection() returned '{0}'", direction);

            while (true) { }
        }

        // necessary to make C# projects work with different installed versions of Mobile Studio Desktop
        static Assembly CurrentDomain_AssemblyResolve(object sender, ResolveEventArgs args)
        {
            string[] name = args.Name.Split();
            string assem = name[0].Substring(0, name[0].Length - 1);
            if (assem.Equals("RPI_IOBoard"))
            {
                RegistryKey key = Registry.LocalMachine.OpenSubKey("Software\\Rensselaer\\Mobile Studio Desktop");
                string path = (string)key.GetValue("Path");
                return Assembly.LoadFrom(path + "\\" + assem + ".dll");
            }
            else
                return null;
        }
    }
}
